<?php
  /*
   Plugin Name: GPS Mission Stats
   Plugin URI: http://www.bangrocks.com/gpsmissionstats-wordpress-plugin/
   Description: Displays your GPS Mission statistics in your blog
   Version: 1.3
   Author: Jason Oakley (wpplugins@bangrocks.com)
   Author URI: http://www.bangrocks.com/
   */
  /*  Copyright 2009  WauloK  (email : wpplugins@bangrocks.com)
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
   */
   
   /* v1.1 : Added Username form on Widget page so no editing required for that. */
   /* v1.2 : Added Colours and fonts in form on Widget page */
   /* v1.3 : Converted lots of inline styles to CSS */
 
  function widget_gpsmissionstats($args)
  {
      extract($args);
     
        $options = get_option("widget_gpsmissionstats");
  if (!is_array( $options ))
        {
                $options = array(
      'username' => 'Enter Username',
      'pluginwidth' => '175',
      'pluginbg' => '#660099',
      'photobg' => '#660099',
      'usernametext' => '#ffffff',
      'usernamebg' => '#9900ff',
      'usernamefont' => 'Verdana',
      'usernamefontsize' => 'medium',
      'headertext' => '#ffff00',
      'headerbg' => '#9900cc',
      'headerfont' => 'Verdana',
      'headerfontsize' => 'small',
      'subheadertext' => '#000000',
      'subheaderbg' => '#9900cc',
      'subheaderfont' => 'Verdana',
      'subheaderfontsize' => 'small',
      'numberstext' => '#000000',
      'numbersbg' => '#ffff99',
      'numbersfont' => 'Times New Roman',
      'numbersfontsize' => 'x-small'
      );
  }  
     
      echo $before_widget;
      echo $before_title . 'GPS Mission Stats' . $after_title;

      // Get Username from Widget form...
      $Username = $options['username'];
     
      // Start customisation. Feel free to edit the variables below...

      // Anything else under here is optional to edit.
      // Plugin width
      $PluginWidth = $options['pluginwidth'];
      // Colours & settings for CSS tables
      // Widget background colour
      $CSSPluginBG = $options['pluginbg'];
      //  - Username
      $CSSUsername = $options['usernametext'];
      $CSSUsernameBG = $options['usernamebg'];
      $CSSUsernameFont = $options['usernamefont'];
      $CSSUsernameFontSize = $options['usernamefontsize'];
      //  - Photo width & height
      $CSSPhotoBG = $options['photobg'];
      //  - header
      $CSSHeaderColour = $options['headertext'];
      $CSSHeaderBG = $options['headerbg'];
      $CSSHeaderFont = $options['headerfont'];
      $CSSHeaderFontSize = $options['headerfontsize'];
      //  - subheader
      $CSSSubheaderColour = $options['subheadertext'];
      $CSSSubheaderBG = $options['subheaderbg'];
      $CSSSubheaderFont = $options['subheaderfont'];
      $CSSSubheaderFontSize = $options['subheaderfontsize'];
      //  - numbers
      $CSSNumbersColour = $options['numberstext'];
      $CSSNumbersBG = $options['numbersbg'];
      $CSSNumbersFont = $options['numbersfont'];
      $CSSNumbersFontSize = $options['numbersfontsize'];
      // ---------- All cusomisation above. No need to edit below this line ------------
     
      // URL to page with profile stats
      $ProfileURL = "http://www.gpsmission.com/user/$Username/profile";
      // URL prefix for profile pic
      $PhotoURLPrefix = "http:\/\/gpsmission.com\/media\/";
      // get the HTML
      $html = file_get_contents($ProfileURL);
      // RegEX for gold owned
      $GoldOwnedRE_L = "<div style=\"padding-top:16px;\"> <b>";
      $GoldOwnedRE_R = "<\/b> <\/div>";
      // Statistics RegExs
      $StatsRE_L = "<span style=\"position:relative;top:-20px;left:10px;\">";
      $StatsRE_R = "<\/span><\/div><\/td>";
      // RegEX for Number of Trophies
      $TrophiesNoRE_L = $StatsRE_L;
      $TrophiesNoRE_R = '<\/span> <\/div><\/td>';
      // RegEX for Value of Trophies
      $TrophiesValRE_L = $StatsRE_L;
      $TrophiesValRE_R = ' <\/span><\/div><\/td>';
      // RegEX for Distance In-Game
      $DistanceIGRE_L = "height:42px;\">";
      $DistanceIGRE_R = "<\/div><\/td>";
     
      // A RegEx-ing we shall goooo.....
      // - Get photo info
      $pattern = "/" . $PhotoURLPrefix . "(\d)+.jpg/";
      $match = preg_match($pattern, $html, $matches);
      $PhotoURL = $matches[0];
      // - Get gold owned
      $pattern = "/" . $GoldOwnedRE_L . "(\S)+" . $GoldOwnedRE_R . "/";
      $match = preg_match($pattern, $html, $matches);
      $GoldOwned = $matches[0];
      $GoldOwned = preg_replace("/$GoldOwnedRE_L/", "", $GoldOwned);
      $GoldOwned = preg_replace("/$GoldOwnedRE_R/", "", $GoldOwned);
      // - Get stats info
      $pattern = "/" . $StatsRE_L . "(\S)+" . $StatsRE_R . "/";
      preg_match_all($pattern, $html, $matches);
      // Gold Collected
      $GoldCollected = $matches[0][0];
      $GoldCollected = preg_replace("/$StatsRE_L/", "", $GoldCollected);
      $GoldCollected = preg_replace("/$StatsRE_R/", "", $GoldCollected);
      // Missions
      $MissionsFinished = $matches[0][3];
      $MissionsFinished = preg_replace("/$StatsRE_L/", "", $MissionsFinished);
      $MissionsFinished = preg_replace("/$StatsRE_R/", "", $MissionsFinished);
      $MissionsCreated = $matches[0][4];
      $MissionsCreated = preg_replace("/$StatsRE_L/", "", $MissionsCreated);
      $MissionsCreated = preg_replace("/$StatsRE_R/", "", $MissionsCreated);
      // Trophies
      $pattern = "/" . $TrophiesNoRE_L . "(\S)+" . $TrophiesNoRE_R . "/";
      $match = preg_match($pattern, $html, $matches);
      $TrophiesNo = $matches[0];
      $TrophiesNo = preg_replace("/$TrophiesNoRE_L/", "", $TrophiesNo);
      $TrophiesNo = preg_replace("/$TrophiesNoRE_R/", "", $TrophiesNo);
      $pattern = "/" . $TrophiesValRE_L . "(\S)+" . $TrophiesValRE_R . "/";
      $match = preg_match($pattern, $html, $matches);
      $TrophiesVal = $matches[0];
      $TrophiesVal = preg_replace("/$TrophiesValRE_L/", "", $TrophiesVal);
      $TrophiesVal = preg_replace("/$TrophiesValRE_R/", "", $TrophiesVal);
      // Distances
      $pattern = "/" . $DistanceIGRE_L . "(.)+" . $DistanceIGRE_R . "/";
      $match = preg_match($pattern, $html, $matches);
      $DistanceIG = $matches[0];
      $DistanceIG = preg_replace("/$DistanceIGRE_L/", "", $DistanceIG);
      $DistanceIG = preg_replace("/$DistanceIGRE_R/", "", $DistanceIG);
      $html = preg_replace("/$DistanceIGRE_L/", "", $html, 1);
      $html = preg_replace("/$DistanceIGRE_R/", "", $html, 1);
      $match = preg_match($pattern, $html, $matches);
      $DistanceBT = $matches[0];
      $DistanceBT = preg_replace("/$DistanceIGRE_L/", "", $DistanceBT);
      $DistanceBT = preg_replace("/$DistanceIGRE_R/", "", $DistanceBT);
     
      // -- Begin output of HTMLs --
      // Output Username styled
      echo("\n<!-- Begin GPS Mission Stats WordPress Widget -->\n"); 
      echo("<style type=\"text/css\">\n");
      echo(".gpsmdiv { display: inline-block; background-color:" . $CSSPluginBG . "; width:" . $PluginWidth . "px; }\n");
      echo(".gpsmusername { display: inline-block; text-align: center; width:" . $PluginWidth . "px; color:" . $CSSUsername . "; background-color:" . $CSSUsernameBG . "; font-size:" . $CSSUsernameFontSize . "; font-family:" . $CSSUsernameFont . "; }\n");
      echo(".gpsmphoto { background-color:" . $CSSPhotoBG . "}\n");
      echo(".gpsmphotospan { display: block; text-align:center; width:" . $PluginWidth . "px;}\n");
      echo(".gpsmheader { display: inline-block; text-align: center; font-weight: bold; width:" . ($PluginWidth) . "px; color:" . $CSSHeaderColour . "; background-color:" . $CSSHeaderBG . "; font-size:" . $CSSHeaderFontSize . "; font-family:" . $CSSHeaderFont . "; }\n");
      echo(".gpsmsubheader { display: inline-block; text-align: center; font-weight: bold; width:" . ($PluginWidth / 2 - 2) . "px; color:" . $CSSSubheaderColour . "; background-color:" . $CSSSubheaderBG . "; font-size:" . $CSSSubheaderFontSize . "; font-family:" . $CSSSubheaderFont . "; }\n");
      echo(".gpsmnumbers { display: inline-block; text-align: center; font-weight: bold; width:" . ($PluginWidth / 2 - 2) . "px; color:" . $CSSNumbersColour . "; background-color:" . $CSSNumbersBG . "; font-size:" . $CSSNumbersFontSize . "; font-family:" . $CSSNumbersFont . "; }\n");
      echo(".gpsmissiontext { display: inline-block; font-size: xx-small; font-family: Verdana; color:#999999; background-color:" . $CSSPluginBG . "; }\n");
      echo(".gpsmissiontextspan { display: inline-block; text-align:center; width:" . $PluginWidth . "px; }\n");
      echo("</style>\n");

      echo("<div class=\"gpsmdiv\">\n");
      echo("<a class =\"gpsmusername\" href=\"" . $ProfileURL . "\">" . $Username . "</a>\n");
      echo("<BR />\n");
      // Output photo
      echo("<span class=\"gpsmphotospan\"><img class=\"gpsmphoto\" src=\"" . $PhotoURL . "?maxWidth=200&maxHeight=150\"></span>\n");
      // Output Gold values
      echo("<span class=\"gpsmheader\">Gold</span>\n");
      echo("<BR />\n");
      echo("<span class=\"gpsmsubheader\">Owned</span>\n");
      echo("<span class=\"gpsmsubheader\">Collected</span>\n");
      echo("<BR />\n");
      echo("<span class=\"gpsmnumbers\">" . $GoldOwned . "</span>\n");
      echo("<span class=\"gpsmnumbers\">" . $GoldCollected . "</span>\n");
      echo("<BR />\n");
     
      // Output Missions values
      echo("<span class=\"gpsmheader\">Missions</span>\n");
      echo("<BR />\n");
      echo("<span class=\"gpsmsubheader\">Finished</span>\n");
      echo("<span class=\"gpsmsubheader\">Created</span>\n");
      echo("<BR />\n");
      echo("<span class=\"gpsmnumbers\">" . $MissionsFinished . "</span>\n");
      echo("<span class=\"gpsmnumbers\">" . $MissionsCreated . "</span>\n");
      echo("<BR />\n");
      // Output Missions values
      echo("<span class=\"gpsmheader\">Trophies</span>\n");
      echo("<BR />\n");
      echo("<span class=\"gpsmsubheader\">Won</span>\n");
      echo("<span class=\"gpsmsubheader\">Values</span>\n");
      echo("<BR />\n");
      echo("<span class=\"gpsmnumbers\">" . $TrophiesNo . "</span>\n");
      echo("<span class=\"gpsmnumbers\">" . $TrophiesVal . "</span>\n");
      echo("<BR />\n");
      // Output Distances values
      echo("<span class=\"gpsmheader\">Distances</span>\n");
      echo("<BR />\n");
      echo("<span class=\"gpsmsubheader\">In-Game</span>\n");
      echo("<span class=\"gpsmsubheader\">Between</span>\n");
      echo("<BR />\n");
      echo("<span class=\"gpsmnumbers\">" . $DistanceIG . "</span>\n");
      echo("<span class=\"gpsmnumbers\">" . $DistanceBT . "</span>\n");
      echo("<span class=\"gpsmissiontextspan\"><a class=\"gpsmissiontext\" href=\"http://www.gpsmission.com/\">GPS Mission</a> | <a class=\"gpsmissiontext\" href=\"http://www.bangrocks.com/gpsmissionstats-wordpress-plugin/\">GPS Mission  Stats</a></span>\n");
      echo("<BR />\n</DIV>\n");
      echo("<!-- End GPS Mission Stats WordPress Widget -->\n");      
     
      echo $after_widget;
  }
 
// Add options form support
function gpsmissionstats_control()
  {
    $options = get_option("widget_gpsmissionstats");
  if (!is_array( $options ))
        {
                $options = array(
      'username' => 'Enter Username',
      'pluginwidth' => '175',
      'pluginbg' => '#660099',
      'photobg' => '#660099',
      'usernametext' => '#ffffff',
      'usernamebg' => '#9900ff',
      'usernamefont' => 'Verdana',
      'usernamefontsize' => 'medium',
      'headertext' => '#ffff00',
      'headerbg' => '#9900cc',
      'headerfont' => 'Verdana',
      'headerfontsize' => 'small',
      'subheadertext' => '#000000',
      'subheaderbg' => '#9900cc',
      'subheaderfont' => 'Verdana',
      'subheaderfontsize' => 'small',
      'numberstext' => '#000000',
      'numbersbg' => '#ffff99',
      'numbersfont' => 'Times New Roman',
      'numbersfontsize' => 'x-small'
      );
  }
  if ($_POST['gpsmissionstats-Submit'])
  {
    $options['username'] = htmlspecialchars($_POST['gpsmissionstats-Username']);
    $options['pluginwidth'] = htmlspecialchars($_POST['gpsmissionstats-PluginWidth']);
    $options['pluginbg'] = htmlspecialchars($_POST['gpsmissionstats-PluginBG']);
    $options['photobg'] = htmlspecialchars($_POST['gpsmissionstats-PhotoBG']);
    $options['usernametext'] = htmlspecialchars($_POST['gpsmissionstats-UsernameText']);
    $options['usernamebg'] = htmlspecialchars($_POST['gpsmissionstats-UsernameBG']);
    $options['usernamefont'] = htmlspecialchars($_POST['gpsmissionstats-UsernameFont']);
    $options['usernamefontsize'] = htmlspecialchars($_POST['gpsmissionstats-UsernameFontSize']);    
    $options['headertext'] = htmlspecialchars($_POST['gpsmissionstats-HeaderText']);
    $options['headerbg'] = htmlspecialchars($_POST['gpsmissionstats-HeaderBG']);
    $options['headerfont'] = htmlspecialchars($_POST['gpsmissionstats-HeaderFont']);
    $options['headerfontsize'] = htmlspecialchars($_POST['gpsmissionstats-HeaderFontSize']);
    $options['subheadertext'] = htmlspecialchars($_POST['gpsmissionstats-SubheaderText']);
    $options['subheaderbg'] = htmlspecialchars($_POST['gpsmissionstats-SubheaderBG']);
    $options['subheaderfont'] = htmlspecialchars($_POST['gpsmissionstats-SubheaderFont']);
    $options['subheaderfontsize'] = htmlspecialchars($_POST['gpsmissionstats-SubheaderFontSize']);    
    $options['numberstext'] = htmlspecialchars($_POST['gpsmissionstats-NumbersText']);
    $options['numbersbg'] = htmlspecialchars($_POST['gpsmissionstats-NumbersBG']);
    $options['numbersfont'] = htmlspecialchars($_POST['gpsmissionstats-NumbersFont']);
    $options['numbersfontsize'] = htmlspecialchars($_POST['gpsmissionstats-NumbersFontSize']);
    update_option("widget_gpsmissionstats", $options);
  }
  ?>
  <p><pre>
    <label for="gpsmissionstats-Username">GPS Mission Username: </label><input type="text" id="gpsmissionstats-Username" name="gpsmissionstats-Username" value="<?php echo $options['username'];?>" />
    <label for="gpsmissionstats-Username">Stats Plugin Width:   </label><input type="text" id="gpsmissionstats-PluginWidth" name="gpsmissionstats-PluginWidth" value="<?php echo $options['pluginwidth'];?>" />
    <span style="display: inline-block; text-align: center; font-weight: bold; color:blue;">Stats Colours</span>
    <label for="gpsmissionstats-PluginBG">Plugin Background:    </label><input type="text" id="gpsmissionstats-PluginBG" name="gpsmissionstats-PluginBG" value="<?php echo $options['pluginbg'];?>" />
    <label for="gpsmissionstats-PhotoBG">Photo Background:     </label><input type="text" id="gpsmissionstats-PhotoBG" name="gpsmissionstats-PhotoBG" value="<?php echo $options['photobg'];?>" />
    <label for="gpsmissionstats-UsernameText">Username Text:        </label><input type="text" id="gpsmissionstats-UsernameText" name="gpsmissionstats-UsernameText" value="<?php echo $options['usernametext'];?>" />
    <label for="gpsmissionstats-UsernameBG">Username Background:  </label><input type="text" id="gpsmissionstats-UsernameBG" name="gpsmissionstats-UsernameBG" value="<?php echo $options['usernamebg'];?>" />
    <label for="gpsmissionstats-HeaderText">Header Text:          </label><input type="text" id="gpsmissionstats-HeaderText" name="gpsmissionstats-HeaderText" value="<?php echo $options['headertext'];?>" />
    <label for="gpsmissionstats-HeaderBG">Header Background:    </label><input type="text" id="gpsmissionstats-HeaderBG" name="gpsmissionstats-HeaderBG" value="<?php echo $options['headerbg'];?>" />
    <label for="gpsmissionstats-SubheaderText">Subheader Text:       </label><input type="text" id="gpsmissionstats-SubheaderText" name="gpsmissionstats-SubheaderText" value="<?php echo $options['subheadertext'];?>" />
    <label for="gpsmissionstats-SubheaderBG">Subheader Background: </label><input type="text" id="gpsmissionstats-SubheaderBG" name="gpsmissionstats-SubheaderBG" value="<?php echo $options['subheaderbg'];?>" />
    <label for="gpsmissionstats-NumbersText">Numbers Text:         </label><input type="text" id="gpsmissionstats-NumbersText" name="gpsmissionstats-NumbersText" value="<?php echo $options['numberstext'];?>" />
    <label for="gpsmissionstats-NumbersBG">Numbers Background:   </label><input type="text" id="gpsmissionstats-NumbersBG" name="gpsmissionstats-NumbersBG" value="<?php echo $options['numbersbg'];?>" />
    <span style="display: inline-block; text-align: center; font-weight: bold; color:blue;">Stats Fonts</span>
    <label for="gpsmissionstats-UsernameFont">Username:             </label><input type="text" id="gpsmissionstats-UsernameFont" name="gpsmissionstats-UsernameFont" value="<?php echo $options['usernamefont'];?>" />
    <label for="gpsmissionstats-UsernameFontSize">Username size:        </label><input type="text" id="gpsmissionstats-UsernameFontSize" name="gpsmissionstats-UsernameFontSize" value="<?php echo $options['usernamefontsize'];?>" />    
    <label for="gpsmissionstats-HeaderFont">Header:               </label><input type="text" id="gpsmissionstats-HeaderFont" name="gpsmissionstats-HeaderFont" value="<?php echo $options['headerfont'];?>" />
    <label for="gpsmissionstats-HeaderFontSize">Header size:          </label><input type="text" id="gpsmissionstats-HeaderFontSize" name="gpsmissionstats-HeaderFontSize" value="<?php echo $options['headerfontsize'];?>" />    
    <label for="gpsmissionstats-SubheaderFont">Subheader:            </label><input type="text" id="gpsmissionstats-SubheaderFont" name="gpsmissionstats-SubheaderFont" value="<?php echo $options['subheaderfont'];?>" />
    <label for="gpsmissionstats-SubheaderFontSize">Subheader size:       </label><input type="text" id="gpsmissionstats-SubheaderFontSize" name="gpsmissionstats-SubheaderFontSize" value="<?php echo $options['subheaderfontsize'];?>" />    
    <label for="gpsmissionstats-NumbersFont">Numbers:              </label><input type="text" id="gpsmissionstats-NumbersFont" name="gpsmissionstats-NumbersFont" value="<?php echo $options['numbersfont'];?>" />
    <label for="gpsmissionstats-NumbersFontSize">Numbers size:         </label><input type="text" id="gpsmissionstats-NumbersFontSize" name="gpsmissionstats-NumbersFontSize" value="<?php echo $options['numbersfontsize'];?>" />    
    <input type="hidden" id="gpsmissionstats-Submit" name="gpsmissionstats-Submit" value="1" />
  </pre></p>
<?php
  }

// Register and init widget
function gpsmissionstats_init()
{
  register_sidebar_widget(__('GPS Mission Stats'), 'widget_gpsmissionstats');
  register_widget_control(   'GPS Mission Stats', 'gpsmissionstats_control', 350, 200 );
}

add_action("plugins_loaded", "gpsmissionstats_init");
 
  // End of plugin
?>